﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MimoX.excepcao
{
    class ExcepcaoHandler
    {

        public static string tratarMensagemDeErroDeLogin(string erro)
        {
            
            if (erro.Contains("Invalid credentials"))
            {
                return "Utilizador ou palavra-passe inválida";
            }
            if (erro.Contains("Username is required"))
            {
                return "Informe o utilizador";
            }
            if (erro.Contains("Invalid username"))
            {
                return "Utilizador inválido";
            }
            if (erro.Contains("A password is required"))
            {
                return "Informe a palavra-passe";
            }
            if (erro.Contains("This user is locked out."))
            {
                return "Esse utilizador está com a conta bloqueada";
            }

            return erro;
        }

        public static string tratarMensagemDeErroDeMimoId(string erro)
        {
            //System.Windows.Forms.MessageBox.Show(erro);
            if (erro.Contains("is already in use"))
            {
                return "O Sender ID que requisitou já pertence a um utilizador";
            }
            if (erro.Contains("reason"))
            {
                return "Informe o motivo da requisição";
            }
            if (erro.Contains("sender"))
            {
                return "Informe o Sender ID que pretende requisitar";
            }

            return "Ocorreu um erro durante a requisição:" + erro + "\n\nPor favor, tente mais tarde.";
        }

        public static string tratarMensagemDeErroDeSms(string erro)
        {
            if (erro.Contains("Existe um ou mais destinatário inválido"))
            {
                return "Existem um ou mais destinatários inválidos";
            }
            else if (erro.Contains("Sem créditos"))
            {
                return "Saldo insuficiente";
            }
            else if (erro.Contains("no recipients"))
            {
                return "Sem destinatário";
            }
            else if (erro.Contains("no recipients"))
            {
                return "Informe a coluna dos destinatários da mensagem";
            }
            else if (erro.Contains("invalid schedule") || erro.Contains("Message not sent. Exceeded the maximum allowed"))
            {
                return "A data/Hora do agendamento está inválida.\nA data/hora do agendamento deve ser superior a data/hora actual e não pode exceder de hoje a 7 dias";
            }
            else if (erro.Contains("Message not sent. Exceeded the maximum allowed"))
            {
                return "Excedeu o tamanho máximo de caracteres (670 - SMS Com caracter especial; e 1530 - SMS sem caracter especial)";
            }

            return "Ocorreu um erro durante a requisição:" + erro + "\n\nPor favor, tente mais tarde.";
        }

        public static string tratarMensagemDeErroDeCredito(string erro)
        {
            if (erro.Contains("Invalid voucher") || erro.Contains("Resource not found") || erro.Contains("voucher not found"))
            {
                return "Código da recarga inválido";
            }
            else if (erro.Contains("is expired"))
            {
                return "O código da recarga expirou";
            }
            else if (erro.Contains("was already used"))
            {
                return "Esse código da recarga já foi utilizado";
            }
            else if (erro.Contains("voucher is required"))
            {
                return "Informe o código da recarga";
            }
            else if (erro.Contains("Unavailable"))
            {
                return "Indisponível";
            }


            return "Ocorreu um erro durante a requisição:" + erro + "\n\nPor favor, tente mais tarde.";
        }

    }
}

