﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;
using MimoX.util;
using MimoX.visao;
using MimoX.constante;
using MimoX.excepcao;

namespace MimoX
{
    public partial class MimoIdForm : Form
    {
        private JsonUtil jsonUtil;
        private RequisicaoHttpUtil requisicaoHttpUtil;

        public MimoIdForm()
        {           
            InitializeComponent();
            inicializarAtributosObrigatorios();

            btnRequisitar.BackColor = cores.AZUL1;

        }
        private void inicializarAtributosObrigatorios()
        {
            requisicaoHttpUtil = new RequisicaoHttpUtil();
            jsonUtil = new JsonUtil();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void splitContainer1_Panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            string mimoId = txtSender.Text.Trim();
            string motivo = txtMotivo.Text.Trim();

            Regex regex = new Regex(@"(\w*[a-zA-Z]+\w*){2,11}");
            if (!regex.Match(mimoId).Success)
            {
                MensagemUtil.mostrarMensagemDeErro("Mimo ID inválido. O Mimo ID só deve ter pelo menos 2 e máximo 11");
                return;
            }

            if (motivo.Length == 0)
            {
                MensagemUtil.mostrarMensagemDeErro("Informe o motivo da requisição do Mimo ID");
                return;
            }

            MimoIdSolicitado mimoIdSolicitado = new MimoIdSolicitado(mimoId, motivo);

            string resultado = requisicaoHttpUtil.executarRequisicaoPost(@"http://52.30.114.86:8080/mimosms/v1/sender-id/request?token=" + Ribbon.TOKEN, jsonUtil.toJson(mimoIdSolicitado));

            if (requisicaoHttpUtil.sucesso)
            {
                Resposta Resposta = new Resposta();
                Resposta = (Resposta)jsonUtil.toObject(resultado, Resposta.GetType());

                limparTela();
                this.Close();
                MensagemUtil.mostrarMensagemDeSucesso("Mimo ID solicitado com sucesso");
            }
            else
            {
                MensagemUtil.mostrarMensagemDeErro(ExcepcaoHandler.tratarMensagemDeErroDeMimoId(resultado));
            }
        }
        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }
        protected override void OnFormClosing(FormClosingEventArgs e)
        {
            base.OnFormClosing(e);

            if (e.CloseReason == CloseReason.WindowsShutDown) return;

            e.Cancel = true;

            limparTela();
            this.Hide();
        }


        private void limparTela()
        {
            txtSender.Text = string.Empty;
            txtMotivo.Text = string.Empty;
        }

        public void mostrarJanela()
        {
            ShowDialog();
            txtSender.Focus();
        }
    }

}

